Page MenuHomePhabricator

Deprecate and remove $wgUseTwoButtonsSearchForm from core
Closed, ResolvedPublic

Description

Having two search submit buttons is bad for site usability. Users end up confused both what button to click and what the heck the difference between them is.

This actually got us a place in a list of things NOT to do:
http://www.smashingmagazine.com/2008/12/04/designing-the-holy-search-box-examples-and-best-practices/

This is basically why simplesearch was introduced in vector.

For other skins however we actually have $wgUseTwoButtonsSearchForm. Which when set to false replaces the unusable "Go" + "Search" with a single "Go" button and an "Advanced search" link that links to the search page and acts as a usable replacement for the fulltext search button.

Current status
  • Deprecated in 1.35
  • Removed in 1.36

Event Timeline

bzimport raised the priority of this task from to Low.Nov 22 2014, 12:49 AM
bzimport set Reference to bz40622.
bzimport added a subscriber: Unknown Object (MLST).

We may also want to consider making it so that the go button in the single-button form says "Search" not "Go". "Go" is a bad name for a search button.

Qgil added a comment.Apr 2 2013, 5:43 AM

fwiw I agree. Who decides?

(In reply to comment #2)

fwiw I agree. Who decides?

The decision shall be made by those who are to blame[1] for the effect the decision will cause.

[1] https://en.wikipedia.org/wiki/User:MZMcBride/Blame_wheel

In all seriousness, I'd say put up a change in Gerrit and we'll see whether those who review changes will approve.

In more seriousness, I approve.

For the record, these are only used by MonoBook and CologneBlue.

Change 145517 had a related patch set uploaded by Rohan013:
$wgUseTwoButtonForm is set to false by default

https://gerrit.wikimedia.org/r/145517

Note: This is no longer used by MonoBook and not used by Vector either. Only used by mediawiki/skins/Nostalgia. Perhaps we should subst Nostalgia's two button form and rid the varirable?

Ah, Config class made it harder to find. Looked for $?wgUseTwoButtonsSearchForm instead of UseTwoButtonsSearchForm.

Both MonoBook and CologneBlue actually still use it.

Wikimedia doesn't currently override this configuration variable so changing this would affect Wikimedia wikis.

Created attachment 16342
Current behaviour (UseTwoButtonsSearchForm=true)

Attached:

Created attachment 16343
Proposed behaviour (UseTwoButtonsSearchForm=false)

Attached:

As stated, we should move away from having a "Go" button. Also, please notice that the search suggestions for Monobook are now the same as Vector, so they contain both exact matches (which "go") and a final "containing..." option (which "search"es).

I suggest:

  1. We rename the "Go" button search, which is more consistent with the Vector search icon button.
  2. We drop the advanced search button, since we have it through the suggestions. If we must keep it, it needs to actually go to the advanced tab of the search page.

(In reply to Trevor Parscal from comment #11)

  1. We drop the advanced search button, since we have it through the

suggestions. If we must keep it, it needs to actually go to the advanced tab
of the search page.

How about hiding it with JS.

Change 145517 abandoned by Krinkle:
Set $wgUseTwoButtonsSearchForm false by default

Reason:
The bug is still under consideration. As it this, this feature would not be enabled by default. Patch can be re-opened or resubmitted later.

https://gerrit.wikimedia.org/r/145517

TheDJ changed the task status from Open to Stalled.Dec 21 2015, 8:14 PM
TheDJ added a subscriber: TheDJ.

This issue has clearly stalled, which is unfortunate.

Qgil removed a subscriber: Qgil.Dec 21 2015, 8:54 PM
Aklapper changed the task status from Stalled to Open.May 21 2020, 11:08 AM
Aklapper lowered the priority of this task from Low to Lowest.
Aklapper added a subscriber: Aklapper.

Going to https://www.mediawiki.org/wiki/Project:Support_desk?useskin=monobook I still see "Go" and "Search" buttons in the sidebar.

The previous comments don't explain what/who exactly this task is stalled on ("If a report is waiting for further input (e.g. from its reporter or a third party) and can currently not be acted on"). Hence resetting task status.

Jdlrobson added a subscriber: Jdlrobson.

Alright bumped into this one today while looking at simplifying our skin architecture.

I propose we remove the UseTwoButtonsSearchForm flag. This is essentially the same as https://gerrit.wikimedia.org/r/#/c/mediawiki/core/+/145517/ but also allows us to remove code in CologneBlue and Monobook relating to the case where we have two.

I think maintaining 2 variants of search in Monobook and CologneBlue is not worth it.

Why are we maintaining this? Is it something controversial in our community?

Jdlrobson renamed this task from Set $wgUseTwoButtonsSearchForm = false by default to Set $wgUseTwoButtonsSearchForm = false by default (...and remove the configuration flag).Jun 12 2020, 8:01 PM

Sounds good to me. If users of either skin do end up preferring to keep two buttons, then it would be trivial to have Monobook and/or CologneBlue do that explicitly the way it has effectively been doing for the past decade - but without it being a core configuration variable.

6 years later, I still agree with Trevor and my former self that this is confusing UX. Having said that, very few people are affected, and I don't think we have any incentive to change it given using Monobook is an explicit opt-in, perhaps even for this reason somehow. Anyway, I think it's minor enough that we can remove it first and restore in-skin later if needed.

Ammarpad raised the priority of this task from Lowest to Needs Triage.

Change 608215 had a related patch set uploaded (by Ammarpad; owner: Ammarpad):
[mediawiki/core@master] Deprecate $wgUseTwoButtonsSearchForm

https://gerrit.wikimedia.org/r/c/mediawiki/core/ /608215

Change 608215 merged by jenkins-bot:
[mediawiki/core@master] Deprecate $wgUseTwoButtonsSearchForm

https://gerrit.wikimedia.org/r/c/mediawiki/core/ /608215

Jdlrobson triaged this task as Medium priority.Jun 29 2020, 11:31 PM
Ammarpad renamed this task from Set $wgUseTwoButtonsSearchForm = false by default (...and remove the configuration flag) to Deprecate and remove $wgUseTwoButtonsSearchForm from core.Jun 30 2020, 11:41 AM
Ammarpad changed the task status from Open to Stalled.
Ammarpad updated the task description. (Show Details)
Ammarpad removed a subscriber: wikibugs-l-list.
Ammarpad changed the task status from Stalled to Open.Sat, Jul 25, 3:14 AM

From my perspective this can be removed as part of 1.36 and resolved. No need to wait till 1.37.

Change 618420 had a related patch set uploaded (by Ammarpad; owner: Ammarpad):
[mediawiki/core@master] Remove $wgUseTwoButtonsSearchForm global

https://gerrit.wikimedia.org/r/618420

Change 618420 merged by jenkins-bot:
[mediawiki/core@master] Remove $wgUseTwoButtonsSearchForm global

https://gerrit.wikimedia.org/r/618420

Jdlrobson updated the task description. (Show Details)Wed, Aug 5, 7:12 PM